Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_end_cycle.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_end_cycle.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_end_cycle.cpp	(revision 88)
@@ -0,0 +1,43 @@
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Dcache_Access.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::end_cycle"
+void Dcache_Access::end_cycle ()
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      _stat->end_cycle();
+#endif    
+
+#ifdef VHDL_TESTBENCH
+    // Evaluation before read the ouput signal
+//  sc_start(0);
+    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
+      _interfaces->testbench();
+#endif
+
+    log_end(Dcache_Access,FUNCTION);
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_req.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_req.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_req.cpp	(revision 88)
@@ -0,0 +1,107 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Dcache_Access.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::genMealy_req"
+  void Dcache_Access::genMealy_req (void)
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+    Tcontrol_t dcache_req_val [_param->_nb_dcache_port];
+    for (uint32_t i=0; i<_param->_nb_dcache_port; ++i)
+      {
+	dcache_req_val [i] = 0;
+	
+#ifdef STATISTICS
+	_internal_DCACHE_REQ_NB_ACCESS         [i] = 0;
+	_internal_DCACHE_REQ_NB_ACCESS_CONFLIT [i] = 0;
+#endif
+      }
+    
+    Tcontrol_t lsq_req_ack [_param->_nb_execute_loop][_param->_max_nb_load_store_unit][_param->_max_nb_cache_access];
+    for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
+      for (uint32_t j=0; j<_param->_nb_load_store_unit[i]; ++j)
+	for (uint32_t k=0; k<_param->_nb_cache_access [i][j]; ++k)
+	  lsq_req_ack [i][j][k] = 0;
+    
+    std::list<generic::priority::select_t> * select = _priority ->select();
+    for (std::list<generic::priority::select_t>::iterator it=select ->begin();
+	 it!=select->end();
+	 ++it)
+      {
+	uint32_t num_execute_loop    = it->grp;
+	uint32_t num_load_store_unit = it->elt;
+	
+	for (uint32_t num_cache_access = 0; num_cache_access<_param->_nb_cache_access [num_execute_loop][num_load_store_unit]; ++num_cache_access)
+	  {
+	    if (PORT_READ(in_LSQ_REQ_VAL [num_execute_loop][num_load_store_unit][num_cache_access]))
+	      {
+		uint32_t   num_port       = _param->_table_routing[num_execute_loop][num_load_store_unit][num_cache_access];
+		Tcontrol_t dcache_req_ack = PORT_READ(in_DCACHE_REQ_ACK [num_port]);
+		
+#ifdef STATISTICS
+		if (dcache_req_ack)
+		  {
+		    _internal_DCACHE_REQ_NB_ACCESS [num_port] ++;
+		    if (dcache_req_val [num_port])
+		    _internal_DCACHE_REQ_NB_ACCESS_CONFLIT [num_port] ++;
+		  }
+#endif
+		if (not dcache_req_val [num_port])
+		  {
+		    dcache_req_val  [num_port] = 1;
+		    lsq_req_ack [num_execute_loop][num_load_store_unit][num_cache_access] = dcache_req_ack;
+		    
+		    if (_param->_have_port_dcache_thread_id)
+                      {
+		    Tcontext_t num_context = (_param->_have_port_lsq_thread_id [num_execute_loop][num_load_store_unit])?PORT_READ(in_LSQ_REQ_THREAD_ID [num_execute_loop][num_load_store_unit][num_cache_access]):0;
+                    PORT_WRITE(out_DCACHE_REQ_THREAD_ID [num_port], _param->_translate_load_store_unit_to_thread[num_execute_loop][num_load_store_unit][num_context]);
+                      }
+// 		    PORT_WRITE(out_DCACHE_REQ_THREAD_ID [num_port], ((num_execute_loop    << _param->_shift_num_execute_loop   )+
+// 								     (num_load_store_unit << _param->_shift_num_load_store_unit)+
+// 								     (num_cache_access    << _param->_shift_num_cache_access   )+
+// 								      num_context));
+ 		    if (_param->_have_port_dcache_packet_id)
+                      {
+                    Tpacket_t packet_id = (_param->_have_port_lsq_packet_id [num_execute_loop][num_load_store_unit])?PORT_READ(in_LSQ_REQ_PACKET_ID [num_execute_loop][num_load_store_unit][num_cache_access]):0;
+                    PORT_WRITE(out_DCACHE_REQ_PACKET_ID [num_port], ((num_cache_access    << _param->_shift_num_cache_access   )+
+                                                                     packet_id));
+                      }
+		    PORT_WRITE(out_DCACHE_REQ_ADDRESS   [num_port], PORT_READ(in_LSQ_REQ_ADDRESS   [num_execute_loop][num_load_store_unit][num_cache_access]));
+		    PORT_WRITE(out_DCACHE_REQ_WDATA     [num_port], PORT_READ(in_LSQ_REQ_WDATA     [num_execute_loop][num_load_store_unit][num_cache_access]));
+		    PORT_WRITE(out_DCACHE_REQ_TYPE      [num_port], PORT_READ(in_LSQ_REQ_TYPE      [num_execute_loop][num_load_store_unit][num_cache_access]));
+		  }
+	      }
+	  }
+      }
+    
+    for (uint32_t i=0; i<_param->_nb_dcache_port; ++i)
+      PORT_WRITE(out_DCACHE_REQ_VAL [i], dcache_req_val [i]);
+    
+    for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
+      for (uint32_t j=0; j<_param->_nb_load_store_unit[i]; ++j)
+	for (uint32_t k=0; k<_param->_nb_cache_access [i][j]; ++k)
+	  PORT_WRITE(out_LSQ_REQ_ACK [i][j][k], lsq_req_ack [i][j][k]);
+
+    log_end(Dcache_Access,FUNCTION);
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_rsp.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_rsp.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_rsp.cpp	(revision 88)
@@ -0,0 +1,98 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Dcache_Access.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::genMealy_rsp"
+  void Dcache_Access::genMealy_rsp (void)
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+    Tcontrol_t lsq_rsp_val [_param->_nb_execute_loop][_param->_max_nb_load_store_unit][_param->_max_nb_cache_access];
+    for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
+      for (uint32_t j=0; j<_param->_nb_load_store_unit[i]; ++j)
+	for (uint32_t k=0; k<_param->_nb_cache_access [i][j]; ++k)
+	  lsq_rsp_val [i][j][k] = 0;
+
+    for (uint32_t i=0; i<_param->_nb_dcache_port; ++i)
+      {
+	Tcontrol_t val = PORT_READ(in_DCACHE_RSP_VAL [i]);
+	Tcontrol_t ack;
+	
+	if (val)
+	  {
+            Tcontext_t thread_id = (_param->_have_port_dcache_thread_id)?PORT_READ(in_DCACHE_RSP_THREAD_ID [i]):0;
+            Tcontext_t packet_id = (_param->_have_port_dcache_packet_id)?PORT_READ(in_DCACHE_RSP_PACKET_ID [i]):0;
+
+	    Tcontext_t execute_loop_id     = _param->_translate_thread_to_execute_loop    [thread_id];
+	    Tcontext_t load_store_unit_id  = _param->_translate_thread_to_load_store_unit [thread_id];
+            Tcontext_t context_id          = _param->_translate_thread_to_context         [thread_id];
+
+	    Tpacket_t  cache_access_id     = (packet_id >> _param->_shift_num_cache_access   ) & _param->_mask_num_cache_access;
+	    Tpacket_t  lsq_packet_id       =  packet_id                                        & _param->_mask_num_lsq_packet;
+
+// 	    log_printf(TRACE,Dcache_Access,FUNCTION,"thread_id          : %d",thread_id);
+// 	    log_printf(TRACE,Dcache_Access,FUNCTION,"execute_loop_id    : %d",execute_loop_id);
+// 	    log_printf(TRACE,Dcache_Access,FUNCTION,"load_store_unit_id : %d",load_store_unit_id);
+// 	    log_printf(TRACE,Dcache_Access,FUNCTION,"cache_access_id    : %d",cache_access_id);
+	    
+#ifdef DEBUG_TEST
+	    if (execute_loop_id > _param->_nb_execute_loop)
+	      throw ERRORMORPHEO(FUNCTION,_("invalid execute_loop_id.\n"));
+
+	    if (load_store_unit_id > _param->_nb_load_store_unit[execute_loop_id])
+	      throw ERRORMORPHEO(FUNCTION,_("invalid load_store_unit_id.\n"));
+
+	    if (context_id > _param->_nb_context[execute_loop_id][load_store_unit_id])
+	      throw ERRORMORPHEO(FUNCTION,_("invalid context_id.\n"));
+
+	    if (cache_access_id > _param->_nb_cache_access[execute_loop_id][load_store_unit_id])
+	      throw ERRORMORPHEO(FUNCTION,_("invalid cache_access_id.\n"));
+
+	    if (_param->_table_routing [execute_loop_id][load_store_unit_id][cache_access_id] != i)
+	      throw ERRORMORPHEO(FUNCTION,_("invalid route.\n"));
+#endif
+
+	    ack = PORT_READ(in_LSQ_RSP_ACK [execute_loop_id][load_store_unit_id][cache_access_id]);
+	    
+	    lsq_rsp_val [execute_loop_id][load_store_unit_id][cache_access_id] = 1;
+
+	    if (_param->_have_port_lsq_thread_id [execute_loop_id][load_store_unit_id])
+	    PORT_WRITE(out_LSQ_RSP_THREAD_ID   [execute_loop_id][load_store_unit_id][cache_access_id], context_id);
+	    if (_param->_have_port_lsq_packet_id [execute_loop_id][load_store_unit_id])
+	    PORT_WRITE(out_LSQ_RSP_PACKET_ID   [execute_loop_id][load_store_unit_id][cache_access_id], lsq_packet_id);
+	    PORT_WRITE(out_LSQ_RSP_RDATA       [execute_loop_id][load_store_unit_id][cache_access_id], PORT_READ(in_DCACHE_RSP_RDATA       [i]));
+	    PORT_WRITE(out_LSQ_RSP_ERROR       [execute_loop_id][load_store_unit_id][cache_access_id], PORT_READ(in_DCACHE_RSP_ERROR       [i]));
+	  }
+	else
+	  ack = 0;
+		
+	PORT_WRITE(out_DCACHE_RSP_ACK [i],ack);
+      }
+
+    for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
+      for (uint32_t j=0; j<_param->_nb_load_store_unit[i]; ++j)
+	for (uint32_t k=0; k<_param->_nb_cache_access [i][j]; ++k)
+	  PORT_WRITE(out_LSQ_RSP_VAL [i][j][k], lsq_rsp_val [i][j][k]);
+
+    log_end(Dcache_Access,FUNCTION);
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_statistics_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_statistics_allocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_statistics_allocation.cpp	(revision 88)
@@ -0,0 +1,70 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Dcache_Access.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::statistics_allocation"
+  void Dcache_Access::statistics_allocation (morpheo::behavioural::Parameters_Statistics * param_statistics)
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+    _stat = new Stat (static_cast<std::string>(_name),
+		      "Dcache_Access",
+		      param_statistics);
+
+    _stat_nb_access         = new counter_t * [_param->_nb_dcache_port];
+    _stat_nb_access_conflit = new counter_t * [_param->_nb_dcache_port];
+
+    std::string _sum_nb_access         = "";
+    std::string _sum_nb_access_conflit = "";
+
+    for (uint32_t i=0; i<_param->_nb_dcache_port; i++)
+      {
+	_stat_nb_access         [i] = _stat->create_counter("nb_access_"        +toString(i),"",toString(_("Total access achieved by all contexts (port %d)"),i));
+	_stat_nb_access_conflit [i] = _stat->create_counter("nb_access_conflit_"+toString(i),"",toString(_("Total access conducting a conflict (port %d)"),i));
+
+	if (i == 0)
+	  {
+	    _sum_nb_access         = "nb_access_0";
+	    _sum_nb_access_conflit = "nb_access_conflit_0";
+	  }
+	else
+	  {
+	    _sum_nb_access         = "+ nb_access_"         +toString(i)+" "+ _sum_nb_access        ;
+	    _sum_nb_access_conflit = "+ nb_access_conflit_" +toString(i)+" "+ _sum_nb_access_conflit;
+	  }
+	
+	_stat->create_expr_percent ("percent_access_conflit_"+toString(i), "nb_access_conflit_"+toString(i), "nb_access_"+toString(i),toString(_("Percent for total access conducting a conflict (port %d)"),i));
+
+
+	_stat->create_expr_average_by_cycle ("average_nb_dcache_access_"+toString(i),"- nb_access_"+toString(i)+" nb_access_conflit_"+toString(i),"",toString(_("Average of dcache access (port %d)"),i));
+      }
+
+    _stat->create_expr         ("nb_access"        , _sum_nb_access        , TYPE_COUNTER, "", _("Total access achieved by all contexts (all port)"));
+    _stat->create_expr         ("nb_access_conflit", _sum_nb_access_conflit, TYPE_COUNTER, "", _("Total access conducting a conflict (all port)"));
+
+    _stat->create_expr_percent ("percent_access_conflit", _sum_nb_access_conflit, _sum_nb_access,_("Percent for total access conducting a conflict"));
+
+    _stat->create_expr_average_by_cycle ("average_nb_dcache_access","- nb_access nb_access_conflit","",_("Average of dcache access (all port)"));
+    
+    log_end(Dcache_Access,FUNCTION);
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_statistics_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_statistics_deallocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_statistics_deallocation.cpp	(revision 88)
@@ -0,0 +1,37 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Dcache_Access.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::statistics_deallocation"
+  void Dcache_Access::statistics_deallocation (void)
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+    log_printf(INFO,Dcache_Access,FUNCTION,_("<%s> : Generate Statistics file"),_name.c_str());
+    
+    delete    _stat;
+    delete [] _stat_nb_access;
+    delete [] _stat_nb_access_conflit;
+    
+    log_end(Dcache_Access,FUNCTION);
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_transition.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_transition.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_transition.cpp	(revision 88)
@@ -0,0 +1,54 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Dcache_Access.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::transition"
+  void Dcache_Access::transition (void)
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+    if (PORT_READ(in_NRESET) == 0)
+      {
+	_priority->reset();
+      }
+    else
+      {
+	// next priority
+	_priority->transition();
+
+#ifdef STATISTICS
+        if (usage_is_set(_usage,USE_STATISTICS))
+          for (uint32_t i=0; i<_param->_nb_dcache_port;i++)
+            {
+              (*_stat_nb_access         [i]) += _internal_DCACHE_REQ_NB_ACCESS         [i];
+              (*_stat_nb_access_conflit [i]) += _internal_DCACHE_REQ_NB_ACCESS_CONFLIT [i];
+            }
+#endif
+      }
+
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+    end_cycle ();
+#endif
+
+    log_end(Dcache_Access,FUNCTION);
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_vhdl.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_vhdl.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_vhdl.cpp	(revision 88)
@@ -0,0 +1,44 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Dcache_Access.h"
+#include "Behavioural/include/Vhdl.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::vhdl"
+  void Dcache_Access::vhdl (void)
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+    Vhdl * vhdl = new Vhdl (_name);
+
+    _interfaces->set_port(vhdl);
+    _component->vhdl_instance(vhdl);
+
+    vhdl_declaration (vhdl);
+    vhdl_body        (vhdl);
+
+    vhdl->generate_file();
+
+    delete vhdl;
+
+    log_end(Dcache_Access,FUNCTION);
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_vhdl_body.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_vhdl_body.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_vhdl_body.cpp	(revision 88)
@@ -0,0 +1,31 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Dcache_Access.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::vhdl_body"
+  void Dcache_Access::vhdl_body (Vhdl * & vhdl)
+  {
+    log_begin(Dcache_Access,FUNCTION);
+    vhdl->set_body ("");
+    log_end(Dcache_Access,FUNCTION);
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_vhdl_declaration.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_vhdl_declaration.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_vhdl_declaration.cpp	(revision 88)
@@ -0,0 +1,30 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Dcache_Access.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::vhdl_declaration"
+  void Dcache_Access::vhdl_declaration (Vhdl * & vhdl)
+  {
+    log_begin(Dcache_Access,FUNCTION);
+    log_end(Dcache_Access,FUNCTION);
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Parameters.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Parameters.cpp	(revision 88)
@@ -0,0 +1,156 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Parameters.h"
+#include "Common/include/Max.h"
+#include "Common/include/BitManipulation.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::Parameters"
+  Parameters::Parameters (uint32_t             nb_thread              ,
+                          uint32_t             nb_execute_loop        ,
+			  uint32_t           * nb_load_store_unit     ,
+			  uint32_t           * nb_context             ,
+			  uint32_t          ** nb_cache_access        ,
+			  uint32_t             nb_dcache_port         ,
+			  uint32_t             size_address           ,
+			  uint32_t             size_data              ,
+                          uint32_t             size_dcache_thread_id  ,
+                          uint32_t             size_dcache_packet_id  ,
+			  uint32_t          ** size_thread_id         ,
+			  uint32_t          ** size_packet_id         ,
+			  uint32_t         *** table_routing          ,
+			  Tpriority_t          priority               ,
+			  Tload_balancing_t    load_balancing         ,
+                          uint32_t         *** translate_load_store_unit_to_thread,
+                          bool                 is_toplevel            )
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+    _nb_thread              = nb_thread         ;
+    _nb_execute_loop        = nb_execute_loop   ;
+    _nb_load_store_unit     = nb_load_store_unit;
+    _nb_context             = nb_context        ;
+    _nb_cache_access        = nb_cache_access   ;
+    _nb_dcache_port         = nb_dcache_port    ;
+    _size_address           = size_address      ;
+    _size_data              = size_data         ;
+    _size_dcache_thread_id  = size_dcache_thread_id;
+    _size_dcache_packet_id  = size_dcache_packet_id;
+    _size_thread_id         = size_thread_id    ;
+    _size_packet_id         = size_packet_id    ;
+    _table_routing          = table_routing     ;
+    _priority               = priority          ;
+    _load_balancing         = load_balancing    ;
+    _translate_load_store_unit_to_thread = translate_load_store_unit_to_thread;
+
+    test();
+
+    _max_nb_load_store_unit = max<uint32_t>(_nb_load_store_unit,  nb_execute_loop);
+    _max_nb_cache_access    = max<uint32_t>(_nb_cache_access   , _nb_execute_loop, _nb_load_store_unit);
+    
+//     _size_dcache_thread_id  = (log2(_nb_execute_loop) +
+// 			       log2(_max_nb_load_store_unit) +
+// 			       log2(_max_nb_cache_access) +
+// 			       _max_size_thread_id);
+
+    uint32_t max_size_packet_id=  max<uint32_t>(_size_packet_id    , _nb_execute_loop, _nb_load_store_unit);
+
+    _shift_num_cache_access    = max_size_packet_id;
+    _mask_num_cache_access     = gen_mask<Tpacket_t>(log2(_max_nb_cache_access));
+    _mask_num_lsq_packet       = gen_mask<Tpacket_t>(max_size_packet_id);
+
+    _have_port_dcache_thread_id= _size_dcache_thread_id > 0;
+    _have_port_dcache_packet_id= _size_dcache_packet_id > 0;
+    
+    _have_port_lsq_thread_id   = new bool * [_nb_execute_loop];
+    _have_port_lsq_packet_id   = new bool * [_nb_execute_loop];
+
+    for (uint32_t i=0; i<_nb_execute_loop; ++i)
+      {
+	_have_port_lsq_thread_id [i] = new bool [_nb_load_store_unit [i]];
+	_have_port_lsq_packet_id [i] = new bool [_nb_load_store_unit [i]];
+
+	for (uint32_t j=0; j<_nb_load_store_unit [i]; ++j)
+	  {
+	    _have_port_lsq_thread_id [i][j] = _size_thread_id[i][j] > 0;
+	    _have_port_lsq_packet_id [i][j] = _size_packet_id[i][j] > 0;
+	  }
+      }
+
+    _translate_thread_to_execute_loop    = new uint32_t [nb_thread];
+    _translate_thread_to_load_store_unit = new uint32_t [nb_thread];
+    _translate_thread_to_context         = new uint32_t [nb_thread];
+
+    for (uint32_t i=0; i<_nb_execute_loop; ++i)
+      for (uint32_t j=0; j<_nb_load_store_unit [i]; ++j)
+        for (uint32_t k=0; k<_nb_context[i]; ++k)
+          {
+            uint32_t num_thread = _translate_load_store_unit_to_thread [i][j][k];
+            
+            _translate_thread_to_execute_loop    [num_thread] = i;
+            _translate_thread_to_load_store_unit [num_thread] = j;
+            _translate_thread_to_context         [num_thread] = k;
+          }
+
+    if (is_toplevel)
+      {
+        copy();
+      }
+
+    log_end(Dcache_Access,FUNCTION);
+  };
+  
+// #undef  FUNCTION
+// #define FUNCTION "Dcache_Access::Parameters (copy)"
+//   Parameters::Parameters (Parameters & param)
+//   {
+//     log_begin(Dcache_Access,FUNCTION);
+//     test();
+//     log_end(Dcache_Access,FUNCTION);
+//   };
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::~Parameters"
+  Parameters::~Parameters (void) 
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+    delete [] _translate_thread_to_context        ;
+    delete [] _translate_thread_to_load_store_unit;
+    delete [] _translate_thread_to_execute_loop   ;
+
+    for (uint32_t i=0; i<_nb_execute_loop; ++i)
+      {
+	delete [] _have_port_lsq_thread_id [i];
+	delete [] _have_port_lsq_packet_id [i];
+      }
+    delete [] _have_port_lsq_thread_id;
+    delete [] _have_port_lsq_packet_id;
+
+    log_end(Dcache_Access,FUNCTION);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::copy"
+  void Parameters::copy (void) 
+  {
+    log_begin(Dcache_Access,FUNCTION);
+    log_end(Dcache_Access,FUNCTION);
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Parameters_msg_error.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Parameters_msg_error.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Parameters_msg_error.cpp	(revision 88)
@@ -0,0 +1,73 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+#include "Behavioural/Core/Dcache_Access/include/Parameters.h"
+#include <sstream>
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::msg_error"
+  Parameters_test Parameters::msg_error(void)
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+    Parameters_test test ("Dcache_Access");
+
+    bool have_link [_nb_dcache_port];
+    for (uint32_t i=0; i<_nb_dcache_port; i++)
+      have_link [i] = 0;
+    
+    for (uint32_t i=0; i<_nb_execute_loop; i++)
+      for (uint32_t j=0; j<_nb_load_store_unit [i]; ++j)
+	for (uint32_t k=0; k<_nb_cache_access [i][j]; ++k)
+	  if (_table_routing [i][j][k] >= _nb_dcache_port)
+	    test.error(toString(_("table_routing [%d][%d][%d] : invalid value, must be < nb_dcache_port.\n"),i,j,k));
+	  else
+	    have_link [_table_routing [i][j][k]] = true;
+    
+    for (uint32_t i=0; i<_nb_dcache_port; i++)
+      if (not have_link [i])
+	test.error(toString(_("Port[%d] is not linked.\n"),i));
+
+    bool thread_link [_nb_thread];
+    for (uint32_t i=0; i<_nb_thread; ++i)
+      thread_link [i] = false;
+    
+    for (uint32_t i=0; i<_nb_execute_loop; i++)
+      for (uint32_t j=0; j<_nb_load_store_unit [i]; j++)
+        for (uint32_t k=0; k<_nb_context[i]; k++)
+          {
+            uint32_t num_thread = _translate_load_store_unit_to_thread [i][j][k];
+            if (num_thread >= _nb_thread)
+              test.error(toString(_("Context [%d][%d][%d] is linked with an invalid thread id.\n"),i,j,k));
+            else
+              if (thread_link [num_thread] == true)
+                test.error(toString(_("Context [%d][%d][%d] is linked with an already used thread id.\n"),i,j,k));
+              else
+                thread_link [num_thread] = true;
+          }
+
+    for (uint32_t i=0; i<_nb_thread; ++i)
+      if (not thread_link [i])
+        test.error(toString(_("Thread [%d] is not linked.\n"),i));
+
+    log_end(Dcache_Access,FUNCTION);
+
+    return test;
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
